import { AbortSignal } from 'abort-controller';
export interface CommitInfo {
    sha1: string;
    author?: string;
    authorMail?: string;
    authorTime?: Date;
    authorTz?: string;
    committer?: string;
    committerMail?: string;
    committerTime?: Date;
    committerTz?: string;
    summary?: string;
    previousHash?: string;
    filename?: string;
}
export interface LineInfo {
    code: string;
    originalLine: number;
    finalLine: number;
    numLines: number;
    commit: CommitInfo | null;
}
export declare class Blamer {
    private concurrencyLimit;
    /** Map from absolute file path to pending blame result */
    private blames;
    constructor(concurrencyLimit: number);
    blameLine(file: string, line: number, signal?: AbortSignal): Promise<CommitInfo | null>;
    private memoizedBlameFile(file, signal?);
    private blameFile(file, signal?);
}
